<!DOCTYPE html>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
    <style>
      body {
        background: black;
        color:#CCCCCC; 
      }
      #c2 {
        /* background-image: url(media/compsis.png); */
        background-image: url(media/fundo.jpg); 
        background-repeat: no-repeat;
        background-size: cover;
      }
      
      div {
        float: left;
        border :1px solid #444444;
        padding:10px;
        margin: 10px;
        background:#3B3B3B;
      }


    </style>
  </head>

  <body>
    <h1>Compsis - Teste de Processamento de Video em tempo real - Frame a Frame</h1>
    <p>Depois de 10 segundos desenhei sobre o v&iacute;deo um poligono em AMARELO - Poderia ser o identificador de objeto
      depois de 10 ele se move. Poderiamos colocar um vetor para ir movimentando com o tempo.


    <div>      
      <video id="video" src="media/out_x264.mp4" controls="true" autoplay width=704 height=480/>
    </div>
    <div>
      <canvas id="c1" width="704" height="480"></canvas>
      <canvas id="c2" width="704" height="480"></canvas>
          </div>

    <div>
      Coordenadas do mouse:
      <p class="sample"></p>
      <p class="sample2"></p>
      <ul id="myList"></ul>
    </div>

  <!--script type="text/javascript" src="processor.js"></script>-->
  <script>


function rgb2hsv (r,g,b) {
 var computedH = 0;
 var computedS = 0;
 var computedV = 0;

 //remove spaces from input RGB values, convert to int
 var r = parseInt( (''+r).replace(/\s/g,''),10 ); 
 var g = parseInt( (''+g).replace(/\s/g,''),10 ); 
 var b = parseInt( (''+b).replace(/\s/g,''),10 ); 

 if ( r==null || g==null || b==null ||
     isNaN(r) || isNaN(g)|| isNaN(b) ) {
   return;
 }
 if (r<0 || g<0 || b<0 || r>255 || g>255 || b>255) {
   return;
 }
 r=r/255; g=g/255; b=b/255;
 var minRGB = Math.min(r,Math.min(g,b));
 var maxRGB = Math.max(r,Math.max(g,b));

 // Black-gray-white
 if (minRGB==maxRGB) {
  computedV = minRGB;
  return [0,0,computedV];
 }

 // Colors other than black-gray-white:
 var d = (r==minRGB) ? g-b : ((b==minRGB) ? r-g : b-r);
 var h = (r==minRGB) ? 3 : ((b==minRGB) ? 1 : 5);
 computedH = 60*(h - d/(maxRGB - minRGB));
 computedS = (maxRGB - minRGB)/maxRGB;
 computedV = maxRGB;
 return [computedH,computedS,computedV];
}



let processor = {
    timerCallback: function() {
      if (this.video.paused || this.video.ended) {
        return;
      }
      this.computeFrame();
      let self = this;
      setTimeout(function () {
          self.timerCallback();
        }, 0);
    },
  
    doLoad: function() {

      let videoResizeRate = 1;

      this.video = document.getElementById("video");
      this.c1 = document.getElementById("c1");
      this.ctx1 = this.c1.getContext("2d");
      this.c2 = document.getElementById("c2");
      this.ctx2 = this.c2.getContext("2d");

      
      let self = this;
      this.video.addEventListener("play", function() {
          self.width = self.video.videoWidth / videoResizeRate;
          self.height = self.video.videoHeight / videoResizeRate;
          self.timerCallback();
        }, false);
    },
  
    computeFrame: function() {
      this.ctx1.drawImage(this.video, 0, 0, this.width, this.height);
      
      let frame = this.ctx1.getImageData(0, 0, this.width, this.height);
          let l = frame.data.length / 4;
  
      let x = 0;
      let y = 0;

      let box_x1 = 100;
      let box_y1 = 40;        
      let box_x2 = 220;
      let box_y2 = 150;

      if(this.video.currentTime > 20) {
        box_x1 = 120;
        box_y1 = 60;        
        box_x2 = 240;
        box_y2 = 170;
      }
      else
      if(this.video.currentTime > 30)      
      {
        box_x1 = 140;
        box_y1 = 80;        
        box_x2 = 260;
        box_y2 = 190;
      }

      for (let i = 0; i < l; i++, x++) {
        if(x >= this.width) {
          x=0;
          y++;
        }

        let r = frame.data[i * 4 + 0];
        let g = frame.data[i * 4 + 1];
        let b = frame.data[i * 4 + 2];
        //if (g > 100 && r > 100 && b < 43)
        
        if(this.video.currentTime > 1 && this.video.currentTime < 40 && 
            (
              //((x >= box_x1 && (x < box_x1 + 2 || (y == box_y1) )) || ( x >= box_x2-2 && x < box_x2)) && (y >= box_y1 && y <= box_y2 ) ||  
              ((y == box_y1 || y == box_y2) && x >= box_x1 && x < box_x2) ||
              ((x == box_x1 || x == box_x2) && y >= box_y1 && y < box_y2)
            )
          ) {
          frame.data[i * 4 + 0]=0;
          frame.data[i * 4 + 1]=222;
          frame.data[i * 4 + 2]=255;
        }
        else
        if (g > 200 && r > 0 && b < 255) {          
          frame.data[i * 4 + 3] = 0;  // Canal alfa
        }

        /*
        if (g > 200 && r > 0 && b < 255) {
          frame.data[i * 4 + 0]=230;
          frame.data[i * 4 + 1]=49;
          frame.data[i * 4 + 2]=182;        
        } 
        */                
         
      }
      this.ctx2.putImageData(frame, 0, 0);
      return;
    }
  };



document.addEventListener("DOMContentLoaded", () => {
  processor.doLoad();
});






    let sampleEle = document.querySelector(".sample");




    document.body.addEventListener("mousemove", (event) => {
       sampleEle.innerHTML = "X: " + event.x + " Y: " + event.y;
    });

    let elementCount = 1;

    let videoEle = document.getElementById("c2");
    let sampleEle2 = document.querySelector(".sample2");
    let list = document.getElementById("myList");

    videoEle.addEventListener("mousemove", (event) => {
      sampleEle2.innerHTML = "X: " + (event.x - videoEle.offsetLeft) + " Y: " + (event.y - videoEle.offsetTop);
    })
    videoEle.addEventListener("click", (event) => {
      sampleEle2.innerHTML = "X: " + (event.x - videoEle.offsetLeft) + " Y: " + (event.y - videoEle.offsetTop) + " (PRESSIONADO)";

      let li = document.createElement("li");
      li.innerText = "Evento [Id: " + elementCount++ + "] X: " + (event.x - videoEle.offsetLeft) + " Y: " + (event.y - videoEle.offsetTop);
      list.appendChild(li);

    })

 </script>

  </body>
</html>
